/**********************************************
* PIC24HJ12GP202 t@~ 
*  IVXR[vvO
**********************************************/
#include <p24HJ12GP202.h>
#include "glcd_lib.h"

/// RtBM[V rbg̐ݒ@ONbN 8MHz
_FBS(BSS_NO_FLASH & BWRP_WRPROTECT_OFF )
_FGS(GSS_OFF & GCP_OFF & GWRP_OFF )
_FOSCSEL(FNOSC_PRIPLL & IESO_ON)
_FOSC(FCKSM_CSECME & IOL1WAY_OFF & POSCMD_XT )
_FWDT(FWDTEN_OFF & WINDIS_OFF)
_FPOR(FPWRT_PWR32 & ALTI2C_OFF)

/// O[oϐ錾
/// t\pσf[^obt@
int Buffer1[192];
int Buffer2[192];
int Index,POT,SW;
char EndFlag;
///@֐vg^CsO
void Oscillo(void);
void AxisDraw(void);
void dotyline(int x0);
void dotxline(int y0);

/************************************************
* C֐
************************************************/
int main(void){
	/* NbN̏ݒ@*/
	CLKDIVbits.PLLPRE = 0;				// PLLPRE=1/2 to 4MHz
	PLLFBDbits.PLLDIV = 40;				// PLLDIV=1/40 to 160MHz
	CLKDIVbits.PLLPOST = 0;				// PLLPOST=1/2 to 80MHz then 40MIPS
	/* |[g̏ݒ */
	AD1PCFGL = 0xFFF8;					// AN0-2 are Analog
	LATB  = 0xFF7F;						// only LCD_E is low 
	TRISA = 0x000F;						// RA4̂ݏo
	TRISB = 0x000F;						// |[g̓o̓[hݒ
	CNPU1 = 0x00E0;						// RB1,2,3 pull up
	/*  t */
	lcd_Init();							// GLCD
	lcd_Clear(0);
	lcd_Str(0, 0, "Start Osccillo");
	/* ADC̐ݒ  */
	AD1CON1  = 0x0044;					// AD OffA10bit, A^C}3gKACH0̂݃Tv
	AD1CON2  = 0x041E;					// AVdd, AVss,8ڊ荞 obt@
	AD1CON3  = 0x0203;					// 2TadTvAad = 3*Tcy 75nsec*14=1.05usec
 	AD1CHS123= 0x0000;					// `l0,1,2,3I
	AD1CHS0  = 0x0000;					// `l0I
	AD1CSSL  = 0x0005;					// XL CH0,2
	AD1PCFGL = 0xFFF8;					// RA0,1,2AiO 
	AD1CON1bits.ADON = 1;				// ADX^[g
	IEC0bits.AD1IE = 1;					// 荞݋
	/** Timer3̐ݒ NbNA1/1AFcy=40MHz  */
	PR3   = 0x018F;						// 10usecC^[o
	T3CON = 0x0000;
	/* ϐ */
	Index = 0;
	EndFlag = 0;
	/****** C@[v@****/	
	while(1){
		/* TvO̐ؑց@*/
		SW = (~PORTB & 0x000E) >> 1;	// 10iXCb`̓
		switch(SW){
			case 0: PR3 = 0x004F;		// 2usec
				break;
			case 1: PR3 = 0x00C7;		// 5usec
				break;
			case 2: PR3 = 0x018F;		// 10usec
				break;
			case 3: PR3 = 0x031F;		// 20usec
				break;
			default:PR3 = 0x018F;		// 10usec 
				break;
		}
		/* ̓f[^̃Ot\ */		
		EndFlag = 0;					// ADtONA
		Index = 0;
		T3CONbits.TON = 1;				// ADRo[^X^[g
		while(!EndFlag);
		Oscillo();						// IVXR[v\
		EndFlag = 0;
		Index = 0;
		Delay1m(500);					// 0.5bŕ\
	}
}
/**************************************
*  AD荞ݏA4`l4
***************************************/
void __attribute__((interrupt, auto_psv)) _ADC1Interrupt(void)
{
	IFS0bits.AD1IF = 0;					// 荞݃tONA
	if(AD1CON2bits.BUFS){
		Buffer1[Index++] = ADC1BUF0;		// ̓f[^obt@Ɉړ
		Buffer1[Index++] = ADC1BUF2;		// 2
		Buffer1[Index++] = ADC1BUF4;		// 3
		Buffer1[Index++] = ADC1BUF6;		// 4
		POT = ADC1BUF7;
	}
	else{
		Buffer1[Index++] = ADC1BUF8;		// ̓f[^obt@Ɉړ
		Buffer1[Index++] = ADC1BUFA;		// 2
		Buffer1[Index++] = ADC1BUFC;		// 3
		Buffer1[Index++] = ADC1BUFE;		// 4
		POT = ADC1BUFF;
	}
	if(Index >= 192){					// f[^obt@tH
		T3CONbits.TON = 0;				// tȂ~tOI
		EndFlag = 1;
	}
}	
	
/************************************************
*  IVXR[v\Aۑf[^\
*  gKoĂ̈ʒu128f[^\
*  gKvȂ΍ŏ128f[^\
*************************************************/
void Oscillo(void){
	int i,x;

	AxisDraw();							// W\
	x = 0;								// ŏ̃f[^
	/* gK`FbN  */
	while((x < 128) && !((Buffer1[x]<POT) && (Buffer1[x+1]>=POT))){
		x++;
	}
	/* gKAg`\  */
	if(x<64){
		for(i=0; i<127; i++){
			lcd_Line(i, Buffer1[i+x]/16, i+1, Buffer1[i+x+1]/16);
//			lcd_Line(i, Buffer2[i+x]/16, i+1, Buffer2[i+x+1]/16);
		}
	}
	/* gKȂAŏ\@*/
	else {
		for(i=0; i<127; i++){
			lcd_Line(i, Buffer1[i]/16, i+1, Buffer1[i+1]/16);
//			lcd_Line(i, Buffer2[i]/16, i+1, Buffer2[i+1]/16);		
		}
	}
}
/******************************************
*  W̕\
*******************************************/
void AxisDraw(void){

	lcd_Clear(0);
	lcd_Line(0, 0, 0, 63);			// Y axis
	dotyline(54);
	dotyline(107);
	lcd_Line(0, 32, 127, 32);		// X axis
	dotxline(49);
	dotxline(16);
	/* TvO̕\ */
	switch(SW){
		case 0: lcd_Str(7,7,"0.2msec/dec");
			break;
		case 1:	lcd_Str(7,7,"0.5msec/dec");
			break;
		case 2:	lcd_Str(7,7,"1.0msec/dec");
			break;
		case 3:	lcd_Str(7,7,"2.0msec/dec"); 
			break;
		default:lcd_Str(7,7,"0.5msec/dec"); 
			break;
	}
}
/************************************
*  XW⏕@_\
************************************/
void dotxline(int y0){
	int i;

	for(i=0; i<128; i+=3)
		lcd_Pixel(i, y0-1, 1);
}
/***********************************
*  YW⏕@_\
***********************************/
void dotyline(int x0){
	int i;

	for(i=0; i<64; i+=3)
		lcd_Pixel(x0-1, i, 1);
}
